const { St, Clutter, GLib, Gio, AccountsService } = imports.gi;
const Main = imports.ui.main;

let panelBin;
let userLabel;

let user;

function updateUser () {
    const realName = user.get_real_name();
    if (realName != null) userLabel.text = realName;
}

function init () {
    panelBin = new St.Bin({
        style_class: 'panel-bin',
    });
    userLabel = new St.Label({
        text: 'No user',
        y_align: Clutter.ActorAlign.CENTER,
    });
    panelBin.set_child(userLabel);

    const userName = GLib.get_user_name();
    user = AccountsService.UserManager.get_default().get_user(userName);
    if (!user) return;

    user.connect('notify::is-loaded', updateUser);
    user.connect('changed', updateUser);
    updateUser();
}

function enable () {
    Main.panel._rightBox.insert_child_at_index(panelBin, 0);
}

function disable () {
    Main.panel._rightBox.remove_child(panelBin);
}
